const config = require('../../config');
const providers = config.providers;
const crypto = require('crypto');
const bcrypt = require('bcrypt');
const moment = require('moment');

module.exports = function(sequelize, DataTypes) {
  const inventory_count_items = sequelize.define(
    'inventory_count_items',
    {
      id: {
        type: DataTypes.UUID,
        defaultValue: DataTypes.UUIDV4,
        primaryKey: true,
      },

quantity_system: {
        type: DataTypes.DECIMAL,
      
      

      },

quantity_counted: {
        type: DataTypes.DECIMAL,
      
      

      },

quantity_diff: {
        type: DataTypes.DECIMAL,
      
      

      },

notes: {
        type: DataTypes.TEXT,
      
      

      },

      importHash: {
        type: DataTypes.STRING(255),
        allowNull: true,
        unique: true,
      },
    },
    {
      timestamps: true,
      paranoid: true,
      freezeTableName: true,
    },
  );

  inventory_count_items.associate = (db) => {


/// loop through entities and it's fields, and if ref === current e[name] and create relation has many on parent entity






































//end loop



    db.inventory_count_items.belongsTo(db.inventory_counts, {
      as: 'inventory_count',
      foreignKey: {
        name: 'inventory_countId',
      },
      constraints: false,
    });

    db.inventory_count_items.belongsTo(db.products, {
      as: 'product',
      foreignKey: {
        name: 'productId',
      },
      constraints: false,
    });

    db.inventory_count_items.belongsTo(db.organizations, {
      as: 'organizations',
      foreignKey: {
        name: 'organizationsId',
      },
      constraints: false,
    });




    db.inventory_count_items.belongsTo(db.users, {
      as: 'createdBy',
    });

    db.inventory_count_items.belongsTo(db.users, {
      as: 'updatedBy',
    });
  };



  return inventory_count_items;
};


